
/*
  cc -g -o ../bin/temp_lock ../src/temp_lock.c
*/

#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <unistd.h>
#include <signal.h>

#include <time.h>
#include <errno.h>
#include <pwd.h>


/* ----------------- IOSUPT ------------------- */


char *Fgets(line,maxl,fp)
char *line;
int maxl;
FILE *fp;
{
int l;
char *ret;
 ret= fgets(line,maxl,fp);
 if(ret==NULL) return(NULL);
 l= strlen(line);
 if(l>0) if(line[l-1]=='\r') line[--l]= 0;
 if(l>0) if(line[l-1]=='\n') line[--l]= 0;
 if(l>0) if(line[l-1]=='\r') line[--l]= 0;
 return(ret);
}


/* ---------------- Username --------------- */

int Get_username(name,name_size,flag)
char *name;
int name_size;
int flag;
{
 struct passwd *pword;
 if(name_size>40)
   sprintf(name,"uid_%ld",(long int) geteuid());
 else
   name[0]= 0;
 pword= getpwuid(geteuid());
 if(pword==NULL) return(0);
 strncpy(name,pword->pw_name,name_size-1);
 name[name_size-1]= 0;
 return(1);
}


/* ---------------- Mikro_sleep ------------- */

int Mikro_sleep(mikrosek,flag)
/* ganz schnell schlafen durch lauschen an keinem File mit select */
unsigned int mikrosek;
int flag;
{
int bereit;
fd_set lfilemaske,sfilemaske,xfilemaske;
#ifdef MIKRO_SCHLAF_DUMMY
  sleep(mikrosek/1000000+1);
#else
 struct timeval wart,tdv,tdn;
 struct timezone zone;

  wart.tv_sec=  mikrosek/1000000;
  wart.tv_usec= mikrosek%1000000;
  gettimeofday(&tdv,&zone);
  FD_ZERO(&lfilemaske); FD_ZERO(&sfilemaske); FD_ZERO(&xfilemaske);
  bereit= select(1,&lfilemaske,&sfilemaske,&xfilemaske,&wart);
  gettimeofday(&tdn,&zone);
#endif
  return(1);
}


int Sleep(seconds,flag)
double seconds;
int flag;
{
 double rest= 0.0,haupt= 0.0;

 if(seconds<=0.0) return(1);
 if(seconds<300.0)
   rest= seconds;
 else{
   haupt= (double) ((int) (seconds-1));
   rest= seconds-haupt;
 }   
 if(haupt>0.0)
   sleep((int) haupt);
 if(rest>0.0)
   Mikro_sleep((int) (rest*1.0e6),0);
 return(1);
}


/* ------------------------ Temp_locK ---------------------- */


#define Temp_lock_sL        4096
#define Temp_lock_head_leN  80
#define Temp_lock_data_leN  480
#define Temp_lock_reV      "lock_temp file format 0"

void  Temp_lock_cleanup();

struct Temp_locK {
 int debug;
 char progname[Temp_lock_sL];
 char errmsg[4*Temp_lock_sL];
 char collision_detect_id[Temp_lock_sL];

 char rev[Temp_lock_sL];
 int in_use;
 double count;

 char address[Temp_lock_sL];
 int header_len;
 int data_len;

 char hostname[Temp_lock_sL];
 char user[Temp_lock_sL];
 char proc[Temp_lock_sL];
 char id[Temp_lock_sL];
 
 double expire_date;    /* UNIX time() extended */
 int exclusive;       /* 0=shared , 1=exclusive */
 double coordination_time;
 int wait_cycles;
 int prewait;

 int action;  /* 
               0= get lock status
               1= try to set lock
               2= try to release lock
              */
};

struct Temp_locK *Temp_lock_busy_lock= NULL;
void  Temp_lock_cleanup();


int Temp_lock_init(tlock,address,flag)
struct Temp_locK *tlock;
char *address;
int flag;
{
 tlock->debug= 0;
 tlock->progname[0]= 0;
 tlock->errmsg[0]= 0;
 tlock->collision_detect_id[0]= 0;

 tlock->rev[0]= 0;
 tlock->in_use= 0;
 tlock->count= 0;
 
 strncpy(tlock->address,address,sizeof(tlock->address)-1);
 tlock->address[sizeof(tlock->address)-1]= 0;
 tlock->header_len= Temp_lock_head_leN;
 tlock->data_len= Temp_lock_data_leN;

 gethostname(tlock->hostname,Temp_lock_sL-1);
 Get_username(tlock->user,sizeof(tlock->user)-1,0);
 sprintf(tlock->proc,"%ld",(long int) getppid());
 tlock->id[0]= 0; 

 tlock->expire_date= time(0)+86400.0;
 tlock->exclusive= 1;
 tlock->coordination_time= 1.0;
 tlock->wait_cycles= 100;
 tlock->prewait= 0;

 tlock->action= 0;
 
 return(1);
}


int Temp_lock_copy(von,nach,flag)
struct Temp_locK *von,*nach;
int flag;
{
 nach->debug= von->debug;
 strcpy(nach->progname,von->progname);
 strcpy(nach->errmsg,von->errmsg);
 strcpy(nach->collision_detect_id,von->collision_detect_id);
 strcpy(nach->rev,von->rev);
 nach->in_use= von->in_use;
 nach->count= von->count;
 strcpy(nach->address,von->address);
 nach->header_len= von->header_len;
 nach->data_len=  von->data_len;
 strcpy(nach->hostname,von->hostname);
 strcpy(nach->user,von->user);
 strcpy(nach->proc,von->proc);
 strcpy(nach->id,von->id);
 nach->expire_date= von->expire_date;
 nach->exclusive= von->exclusive;
 nach->coordination_time= von->coordination_time;
 nach->wait_cycles= von->wait_cycles;
 nach->action= von->action;
 return(1);
}


int Temp_lock_form_id(tlock,flag)
struct Temp_locK *tlock;
int flag;
{
 char line[Temp_lock_sL];

 gethostname(line,Temp_lock_sL-1);
 line[Temp_lock_sL/2]= 0;
 if(tlock->collision_detect_id[0]!='_') 
   sprintf(tlock->collision_detect_id,"%ld@%s",(long int) getpid(),line);
 if(tlock->id[0]) return(1);
 sprintf(tlock->id,"%ld",time(0));
 return(1);
}


/*
 File format:
 
 Header:
   Temp_lock_reV[40]
   header_len=80 data_len=480
 Data (starts at header_bytes):
   count[40]
   expire_date[40]
   id[80]
   hostname[80]
   user[80]
   proc[80]
 Used (starts at header_bytes+data_bytes):
   used[]
   collision_detect_id[]
*/


int Temp_lock_write(tlock,flag)
struct Temp_locK *tlock;
int flag; 
/*
  bit0= nur header und collision_detect_id schreiben
  bit1= in_use bei bit0 
*/
{
 FILE *fp= NULL;
 int i,ret,file_neu=0,wo;
 struct stat stbuf;

 if(tlock->address[0]==0) return(1);
 
 if(stat(tlock->address,&stbuf)==-1) {
   file_neu= 1;
   fp= fopen(tlock->address,"w+");
   chmod(tlock->address,0666);
 } else {
   fp= fopen(tlock->address,"r+");
 }
 if(fp==NULL)
   goto err_ex;
 if(file_neu) {
   for(i=0;i<tlock->header_len+tlock->data_len;i+=80)
     fprintf(fp,"%79.79s\n","");
   fseek(fp,0,0);
   ret= Temp_lock_read_header(tlock,NULL,0);
 } else {
   ret= Temp_lock_read_header(tlock,fp,0);
 }
 if(ret<0) 
   goto err_ex;
 if(ret==0)
   goto ex;
 Temp_lock_form_id(tlock,0);

 /* Header */
 fseek(fp,0,0);
 fprintf(fp,"%s\n",tlock->rev);
 fprintf(fp,"%d %d\n",tlock->header_len,tlock->data_len);

 if(!(flag&1)) {
   /* Data */
   fseek(fp,tlock->header_len,0);
   wo= ftell(fp);
   fprintf(fp,"%lf\n",tlock->count);
   fprintf(fp,"%lf\n",tlock->expire_date);
   fprintf(fp,"%.80s\n",tlock->id);
   fprintf(fp,"%.80s\n",tlock->hostname);
   fprintf(fp,"%.80s\n",tlock->user);
   fprintf(fp,"%.80s\n",tlock->proc);
   fprintf(fp,"@end_of_data@\n");
 }

 fseek(fp,tlock->header_len+tlock->data_len,0);
 wo= ftell(fp);
 if(flag&1) {
   if(flag&2) tlock->in_use= 1;
   else       tlock->in_use= 0;
 }
 fprintf(fp,"%d\n",tlock->in_use);
 fprintf(fp,"%s\n",tlock->collision_detect_id);

 fclose(fp);
 return(1);

err_ex:;
 sprintf(tlock->errmsg,"%s : lock file %s : %s",
                       tlock->progname,tlock->address,strerror(errno));
ex:;
 if(fp!=NULL) fclose(fp);
 return(0);
}


int Temp_lock_read_header(tlock,fp,flag)
struct Temp_locK *tlock;
FILE *fp;
int flag;
{
 char line[Temp_lock_sL];

 if(fp==NULL){
   strcpy(tlock->rev,Temp_lock_reV);
   tlock->header_len= Temp_lock_head_leN;
   tlock->data_len= Temp_lock_data_leN;
   return(1);
 }
 fseek(fp,0,0);
 if(Fgets(tlock->rev,Temp_lock_sL-1,fp)==NULL) 
   goto err_ex;
 if(strcmp(tlock->rev,Temp_lock_reV)!=0) {
   sprintf(tlock->errmsg,"%s : lock file revision incompatible : %s",
                         tlock->progname,tlock->rev);
   return(0);
 }  
 if(Fgets(line,Temp_lock_sL-1,fp)==NULL) 
   goto err_ex;
 sscanf(line,"%d %d",&(tlock->header_len),&(tlock->data_len));
 return(1);
err_ex:;
 return(-1); 
}


int Temp_lock_read(tlock,flag)
struct Temp_locK *tlock;
int flag;
/*
 bit0= nur collision_detect_id lesen 
*/
{
 FILE *fp;
 char line[Temp_lock_sL];
 struct stat stbuf;
 int ret= 0,reasonable_length= 256;

 if(reasonable_length>Temp_lock_sL/2-1)
   reasonable_length= Temp_lock_sL/2-1;

 if(tlock->address[0]==0)
   return(1);
 
 if(stat(tlock->address,&stbuf)==-1){
   /* kein File: Defaultbelegung */
   Temp_lock_read_header(tlock,NULL,0);
   if(!(flag&1))
     tlock->count= 0.0;
   tlock->in_use= 0;
   return(1);
 }

 fp= fopen(tlock->address,"r");
 if(fp==NULL){
   strncpy(tlock->errmsg,strerror(errno),sizeof(tlock->errmsg)-1);
   tlock->errmsg[sizeof(tlock->errmsg)-1]= 0;
   return(0);
 }
 ret= Temp_lock_read_header(tlock,fp,0);
 if(ret<0) 
   goto err_ex;
 if(ret==0)
   goto ex;

 if(!(flag&1)) {
   /* Data */
   fseek(fp,tlock->header_len,0);
   if(Fgets(line,Temp_lock_sL-1,fp)==NULL) 
     goto err_ex;
   sscanf(line,"%lf",&(tlock->count));
   if(Fgets(line,Temp_lock_sL-1,fp)==NULL) 
     goto err_ex;
   sscanf(line,"%lf",&(tlock->expire_date));
   /* abgelaufen ? */
   if(tlock->expire_date<time(0)) 
     tlock->count=0;
   if(Fgets(tlock->id,Temp_lock_sL-1,fp)==NULL) 
     goto err_ex;
   tlock->id[reasonable_length]= 0;
   if(Fgets(tlock->hostname,Temp_lock_sL-1,fp)==NULL) 
     goto err_ex;
   tlock->hostname[reasonable_length]= 0;
   if(Fgets(tlock->user,Temp_lock_sL-1,fp)==NULL) 
     goto err_ex;
   tlock->user[reasonable_length]= 0;
   if(Fgets(tlock->proc,Temp_lock_sL-1,fp)==NULL) 
     goto err_ex;
   tlock->proc[reasonable_length]= 0;
 }

 /* Used */
 fseek(fp,tlock->header_len+tlock->data_len,0);
 if(Fgets(line,Temp_lock_sL-1,fp)==NULL) 
   goto err_ex;
 sscanf(line,"%d",&(tlock->in_use));
 if(Fgets(tlock->collision_detect_id,Temp_lock_sL-1,fp)==NULL) 
   goto err_ex;
 tlock->collision_detect_id[2*reasonable_length]= 0;

 fclose(fp);
 return(1);
err_ex:;
 sprintf(tlock->errmsg,"%s : lock file %s : %s",
                       tlock->progname,tlock->address,strerror(errno));
ex:;
 fclose(fp);
 return(0);
}


int Temp_lock_reserve(tlock,flag)
struct Temp_locK *tlock;
int flag;
{
 struct Temp_locK *prob,prob_local;
 struct stat stbuf;
 int versuche;
 double warten;

 prob= &prob_local;
 Temp_lock_init(prob,"",0);

 if(stat(tlock->address,&stbuf)==-1) {
   /* write unlocked file */
   if(Temp_lock_write(tlock,1)<=0)
     return(0);
 }

 /* warten, bis der File unbenutzt erscheint */
 if(tlock->prewait){
   warten= 3.0*tlock->coordination_time;
   Sleep(warten,0);
 }
 versuche= 0;
versuchen:;
 Temp_lock_copy(tlock,prob,0);
 for(;versuche<tlock->wait_cycles;versuche++) {
   if(Temp_lock_read(prob,1)<=0)
     return(0);
 if(prob->in_use==0) break;
   /* mit abnehmender Geduld warten */
   warten= (2.0/((double)versuche+1.0))*tlock->coordination_time;
   Sleep(warten,0);
 }
 if(versuche>=tlock->wait_cycles) {
   sprintf(tlock->errmsg,"%s : patience expired after %d tries",
                         tlock->progname,tlock->wait_cycles);
   return(0);
 }

 /* DEBUG: eine grosse Trefferflaeche fuer Kollisionen schaffen */
 if(tlock->debug)
   Sleep(0.5,0);

 /* File reservieren */
 Temp_lock_set_cleanup(tlock,0);
 if(Temp_lock_write(tlock,3)<=0)
   return(0);
 Sleep(tlock->coordination_time,0);
 if(Temp_lock_read(prob,1)<=0)
   return(0);
 /* Ist die Reservierungsanmeldung noch da ? */
 if(strcmp(tlock->collision_detect_id,prob->collision_detect_id)!=0
    || !tlock->in_use){
   if(tlock->debug)
     fprintf(stderr,"%ld : collision on first test : 1 %s <> %d %s\n",
                    (unsigned long) getpid(),tlock->collision_detect_id,
                    prob->in_use,prob->collision_detect_id);
   /* Kollision: wegen moeglicher Mischung der IDs wieder ungueltig machen */
   if(strlen(tlock->collision_detect_id)>=sizeof(prob->collision_detect_id)-10)
     strcpy(prob->collision_detect_id,"_eraser_");
   else
     sprintf(prob->collision_detect_id,"_eraser_%s",tlock->collision_detect_id);
   Temp_lock_unreserve(prob,0);
   /* eine zufaellige Zeit warten */
   warten= drand48()*2.0*tlock->coordination_time;
   Sleep(warten,0);
   goto versuchen;
 }
 /* Nochmal warten, falls ein anderer den _eraser_ losgeschickt hat */
 Sleep(tlock->coordination_time,0);
 if(Temp_lock_read(prob,1)<=0)
   return(0);
 if(strcmp(tlock->collision_detect_id,prob->collision_detect_id)!=0
    || !tlock->in_use){
   /* Ein _eraser_ hat doch noch aufgemacht (evtl. schon wieder neue dran) */
   if(tlock->debug)
     fprintf(stderr,"* %ld : collision on second test : 1 %s <> %d %s\n",
                    (long int) getpid(),tlock->collision_detect_id,
                    prob->in_use,prob->collision_detect_id);
   goto versuchen;
 }

 return(1);
}


int Temp_lock_unreserve(tlock,flag)
struct Temp_locK *tlock;
int flag;
{
 if(Temp_lock_write(tlock,1)<=0)
   return(0);
 Temp_lock_set_cleanup(tlock,1);
 return(1);
}


int Temp_lock_emergency_unreserve(tlock,flag)
struct Temp_locK *tlock;
int flag;
{
 struct Temp_locK *prob,prob_loc;
 prob= &prob_loc;
 Temp_lock_init(prob,"",0);
 Temp_lock_copy(tlock,prob,0);
 return(Temp_lock_unreserve(prob,0));
}


int Temp_lock_set_cleanup(tlock,flag)
struct Temp_locK *tlock;
int flag;
/*
 bit0= defaultwerte setzen 
*/
{ 
 if(flag&0) goto abschalten;

 Temp_lock_busy_lock= tlock;
 signal(SIGHUP,Temp_lock_cleanup);
 signal(SIGINT,Temp_lock_cleanup);
 signal(SIGQUIT,Temp_lock_cleanup);
 signal(SIGILL,Temp_lock_cleanup);
 signal(SIGTRAP,Temp_lock_cleanup);
 signal(SIGIOT,Temp_lock_cleanup);
/* signal(SIGEMT,Temp_lock_cleanup); */
 signal(SIGFPE,Temp_lock_cleanup);
 signal(SIGBUS,Temp_lock_cleanup);
 signal(SIGSEGV,Temp_lock_cleanup);
/* signal(SIGSYS,Temp_lock_cleanup); */
 signal(SIGPIPE,Temp_lock_cleanup);
 signal(SIGALRM,Temp_lock_cleanup);
 signal(SIGTERM,Temp_lock_cleanup);
 signal(SIGUSR1,Temp_lock_cleanup);
 signal(SIGUSR2,Temp_lock_cleanup);
 signal(SIGURG,Temp_lock_cleanup);
 signal(SIGXCPU,Temp_lock_cleanup);
 signal(SIGXFSZ,Temp_lock_cleanup);
 signal(SIGVTALRM,Temp_lock_cleanup);
 signal(SIGPROF,Temp_lock_cleanup);
 return(1);
abschalten:;
 Temp_lock_busy_lock= NULL;
 signal(SIGHUP,SIG_DFL);
 signal(SIGINT,SIG_DFL);
 signal(SIGQUIT,SIG_DFL);
 signal(SIGILL,SIG_DFL);
 signal(SIGTRAP,SIG_DFL);
 signal(SIGIOT,SIG_DFL);
/* signal(SIGEMT,SIG_DFL); */
 signal(SIGFPE,SIG_DFL);
 signal(SIGBUS,SIG_DFL);
 signal(SIGSEGV,SIG_DFL);
/* signal(SIGSYS,SIG_DFL); */
 signal(SIGPIPE,SIG_DFL);
 signal(SIGALRM,SIG_DFL);
 signal(SIGTERM,SIG_DFL);
 signal(SIGUSR1,SIG_DFL);
 signal(SIGUSR2,SIG_DFL);
 signal(SIGURG,SIG_DFL);
 signal(SIGXCPU,SIG_DFL);
 signal(SIGXFSZ,SIG_DFL);
 signal(SIGVTALRM,SIG_DFL);
 signal(SIGPROF,SIG_DFL);
 return(1);
}


void Temp_lock_cleanup()
{
 if(Temp_lock_busy_lock==NULL) exit(1);
 fprintf(stderr,"%s : handling emergency on lockfile %s\n",Temp_lock_busy_lock->progname,
                                               Temp_lock_busy_lock->address);
 Temp_lock_emergency_unreserve(Temp_lock_busy_lock,0);
 exit(1);
}


int Temp_lock_query_print(tlock,flag)
struct Temp_locK *tlock;
int flag;
{
 char line[6*Temp_lock_sL];

 if(tlock->count<0) {
   sprintf(line,"-1  (exclusive lock)\n");
 } else if(tlock->count==1.0) {
   sprintf(line,"%1.lf (nonexclusive lock)\n",tlock->count);
 } else if(tlock->count>0) {
   sprintf(line,"%1.lf (nonexclusive locks)\n",tlock->count);
 } else {
   sprintf(line,"0 (not locked)\n");
 }
 sprintf(line+strlen(line),
         " host=\"%s\"\n user=\"%s\"\n process=\"%s\"\n",
         tlock->hostname,tlock->user,tlock->proc);
 sprintf(line+strlen(line),
         " file=\"%s\"\n id=\"%s\"\n lifetime=%1.lf\n",
         tlock->address,tlock->id,tlock->expire_date-time(0));
         
 if(flag&1)
   fprintf(stderr,"%s",line);
 else
   printf("%s",line);
 return(1);
}


int Temp_lock_query(tlock,flag)
struct Temp_locK *tlock;
int flag;
{
 if(Temp_lock_reserve(tlock,0)<=0)
   return(0);
 if(Temp_lock_read(tlock,0)<=0) {
   Temp_lock_emergency_unreserve(tlock,0);
   return(0);
 }
 Temp_lock_query_print(tlock,0);
 if(Temp_lock_unreserve(tlock,0)<=0)
   return(0);
 return(1);
}


int Temp_lock_obtain(tlock,flag)
struct Temp_locK *tlock;
int flag;
{
 int ret;
 struct Temp_locK *kopie,kopie_loc;

 kopie= &kopie_loc;
 Temp_lock_init(kopie,"",0);
 Temp_lock_copy(tlock,kopie,0);

 if(Temp_lock_reserve(tlock,0)<=0)
   return(-1);

 /* Status pruefen */
 if(Temp_lock_read(tlock,0)<=0)
   goto ex;
 if(tlock->count!=0) {
   if(tlock->exclusive || tlock->count<0) {
     ret= 0;
     goto fertig;
   }
 }

 /* Eigenschaften durchschreiben */
 if(tlock->count==0){
   /* als Gruender des Lock eintragen */
   strcpy(tlock->hostname,kopie->hostname);
   strcpy(tlock->user,kopie->user);
   strcpy(tlock->proc,kopie->proc);
   tlock->expire_date= kopie->expire_date;
   strcpy(tlock->id,kopie->id);
 }
 if(tlock->expire_date<kopie->expire_date)
   tlock->expire_date= kopie->expire_date;

 /* neuen Zaehlerstand festlegen und schreiben */
 if(tlock->exclusive) tlock->count= -1;
 else                 tlock->count++;
 if(Temp_lock_write(tlock,0)<=0)
   goto ex;

 printf("%s\n",tlock->id);
 ret= 1;
fertig:;
 if(Temp_lock_unreserve(tlock,0)<=0)
   return(-1);
 return(ret);
ex:;
 Temp_lock_emergency_unreserve(tlock,0);
 return(-1);
}


int Temp_lock_release(tlock,flag)
struct Temp_locK *tlock;
int flag;
{
 int ret;
 struct Temp_locK *kopie,kopie_loc;

 if(tlock->id[0]==0) {
   sprintf(tlock->errmsg,"%s : no -id set for -action \"release\"",
                         tlock->progname);
   return(0);
 }

 kopie= &kopie_loc;
 Temp_lock_init(kopie,"",0);
 Temp_lock_copy(tlock,kopie,0);

 if(Temp_lock_reserve(tlock,0)<=0)
   return(0);
 
 /* Status pruefen */
 if(Temp_lock_read(tlock,0)<=0)
   goto ex;

 /* id pruefen */
 if(tlock->count!=0 && strcmp(tlock->id,kopie->id)!=0){
   sprintf(tlock->errmsg,
           "%s : -id \"%s\" doesn't match id of lock file (\"%s\")",
           tlock->progname,kopie->id,tlock->id);
   ret= 0;
   goto fertig;
 }

 /* Lock freigeben */
 if(tlock->count==0){
   ;
 } else if(tlock->count<0) {
   tlock->count= 0;
 } else if(tlock->count>0) {
   tlock->count--;
 }
 if(Temp_lock_write(tlock,0)<=0)
   goto ex;

 printf("%1.lf\n",tlock->count);

 ret= 1;
fertig:;
 if(Temp_lock_unreserve(tlock,0)<=0)
   return(-1);
 return(ret);
ex:;
 Temp_lock_emergency_unreserve(tlock,0);
 return(-1);
}


int Temp_lock_refresh(tlock,flag)
struct Temp_locK *tlock;
int flag;
/*
 bit0= auf existierendem Lock bestehen 
*/
{
 int ret= 0;
 struct Temp_locK *kopie,kopie_loc;

 if(tlock->id[0]==0) {
   sprintf(tlock->errmsg,"%s : no -id set for -action \"refresh\"",
                         tlock->progname);
   return(0);
 }

 kopie= &kopie_loc;
 Temp_lock_init(kopie,"",0);
 Temp_lock_copy(tlock,kopie,0);

 if(Temp_lock_reserve(tlock,0)<=0)
   return(0);
 
 /* Status pruefen */
 if(Temp_lock_read(tlock,0)<=0)
   goto ex;
 if(tlock->count==0) {
   printf("0\n");
   if((flag&1)) ret= 2;
   else         ret= 1;
   goto fertig;
 }

 /* id pruefen */
 if(tlock->count!=0 && strcmp(tlock->id,kopie->id)!=0){
   sprintf(tlock->errmsg,
           "%s : -id \"%s\" doesn't match id of lock file (\"%s\")",
           tlock->progname,kopie->id,tlock->id);
   ret= 0;
   goto fertig;
 }

 /* Lock Verfallsdatum auffrischen  */
 if(tlock->expire_date<kopie->expire_date)
   tlock->expire_date= kopie->expire_date;

 if(Temp_lock_write(tlock,0)<=0)
   goto ex;

 printf("%1.lf\n",tlock->expire_date-time(0));

 ret= 1;
fertig:;
 if(Temp_lock_unreserve(tlock,0)<=0)
   return(-1);
 return(ret);
ex:;
 Temp_lock_emergency_unreserve(tlock,0);
 return(-1);
}


int Temp_lock_perform(tlock,flag)
struct Temp_locK *tlock;
int flag;
{
 int ret= 0;
 if(tlock->address[0]==0) return(1);
 if(tlock->action==0){
   ret= Temp_lock_query(tlock,0);
 } else if (tlock->action==1){
   ret= Temp_lock_obtain(tlock,0);
   if(ret==0) {
     fprintf(stderr,"%s : can't obtain %slock on %s\n",
                    tlock->progname,(tlock->exclusive?"exclusive ":""),
                    tlock->address);
     Temp_lock_query_print(tlock,0);
   }
 }else if (tlock->action==2) {
   ret= Temp_lock_release(tlock,0);
   if(ret==0) {
     fprintf(stderr,"%s\n",tlock->errmsg);
     tlock->errmsg[0]= 0;
     Temp_lock_query_print(tlock,0);
   }
 }else if (tlock->action==3) {
   ret= Temp_lock_refresh(tlock,1);
   if(ret==0) {
     fprintf(stderr,"%s\n",tlock->errmsg);
     tlock->errmsg[0]= 0;
     Temp_lock_query_print(tlock,0);
   }
   if(ret==2) ret= 0;
 }
 if(ret<0) return(2);
 if(ret==0) return(1);
 return(0);
}


int Temp_lock_help(tlock,flag)
struct Temp_locK *tlock;
int flag;
{
 static char hilfetext[][80]={
"usage :  %s  -name filename [options]",
"",
"temp_lock Version 0.1",
"",
"Locks an object depicted by -name . The lock is respected by the other",
"instances of this program. So any program which is concerned with a locked",
"object should call %s prior to accessing this object.",
"The locks have limited life time so that forgotten ones do not block the",
"system forever. A brute force method to release a lock is to delete the",
"lock file (-action \"release\" is the regular way).",
"",
"options:",
"",
"  -name filename  name of the lock file. The connection to the object that",
"                  is actually to be locked has to be made by the caller.",
"                  (this option is mandatory and has no default setting)",
"  -sleep seconds  the coordination time. This time should be longer than",
"        [1..300]  the maximum time to read and write about 1 kB of data",
"                  to the file under heavy load on network and system.",
"                  (default: 1 which is usable for fast systems)",
"  -prewait        wait 3 times the -sleep time before attempting to",
"                  access the lock file. This option results in a better",
"                  work balance on lock files which are heavily used.",
"  -proc text      the process identifier - will be printed as part of a",
"                  query. (default: parent's process id)",
"  -lifetime seconds  define the maximum lifetime of the lock.",
"                  (0=forever , default: 86400 = 1 day)",
"  -exclusive      require to be the only owner of the lock.",
"                  (default)",
"  -non_exclusive  be ready to co-exist with other -non_exclusive locks",
"",
"  -id text        set lock id. Needed for -action \"release\" and \"refresh\"",
"                  May be used for \"lock\" too, but only applies if the lock",
"                  was not set before.",
"  -action task    define the task to be performed. Possible tasks are:",
"                    query ..... print the current locking state (default)",
"                                first word: 0=not locked, -1=exclusive lock,",
"                                            >0=number of non exclusive locks,",
"                    lock ...... obtain a lock.",
"                                exit 0 and print id of lock if successful",
"                                exit 1 and print query result if failed",
"                    release ... release a lock. Needs valid -id ",
"                                print remaining number of locks (or exit 1)",
"                    refresh ... test and possibly update a lock's lifetime",
"                                Needs valid -id",
"                                exit 0 and print lifetime if lock is set",
"                                       lifetime is at least as in -lifetime",
"                                exit 1 and print 0 if lock is not set",
"Examples:",
" Get an exclusive lock on /home/locks/cdr_3_0 :",
"   $ id=\"$(temp_lock -name /home/locks/cdr_3_0 -action lock)\"",
" release this lock",
"   $ temp_lock -name /home/locks/cdr_3_0 -action release -id $id",
" if you forgot the id :",
"   $ temp_lock -name /home/locks/cdr_3_0 -action query",
"   -1  (exclusive lock)",
"    host=\"ts1\"",
"    user=\"thomas\"",
"    process=\"231\"",
"    file=\"/home/locks/cdr_3_0\"",
"    id=\"938276484\"",
"    lifetime=846",
" (this lock is exclusive, has id 938101981 and will expire in 846 seconds)",
"",
"@ENDE_DES_HILFETEXTS_(HOFFENTLICH_EINMALIG_DOOFER_TEXT)@"
 };
 char line[4096];
 int i;

 for(i=0;strcmp(hilfetext[i],
                "@ENDE_DES_HILFETEXTS_(HOFFENTLICH_EINMALIG_DOOFER_TEXT)@"
                )!=0;i++){
   sprintf(line,hilfetext[i],tlock->progname);
   fprintf(stdout,"%s\n",line);
 }
 return(1);
}


int Temp_lock_setup(tlock,argc,argv,flag)
struct Temp_locK *tlock;
int argc;
char **argv;
int flag;
{
 int i;
 double zahl;

 strncpy(tlock->progname,argv[0],sizeof(tlock->progname)-1);
 tlock->progname[sizeof(tlock->progname)-1]= 0;

 for(i=1;i<argc;i++){
   if(strcmp(argv[i],"-name")==0 && i+1<argc){
     i++;
     strncpy(tlock->address,argv[i],sizeof(tlock->address)-1);
     tlock->address[sizeof(tlock->address)-1]= 0;
   } else if(strcmp(argv[i],"-id")==0 && i+1<argc){
     i++;
     strncpy(tlock->id,argv[i],sizeof(tlock->id)-1);
     tlock->id[sizeof(tlock->id)-1]= 0;
   } else if(strcmp(argv[i],"-sleep")==0 && i+1<argc){
     i++;
     sscanf(argv[i],"%lf",&zahl);
     if(zahl<0.0) zahl= 0.0;
     else if(zahl>300.0) zahl= 300.0;
     tlock->coordination_time= zahl;
   } else if(strcmp(argv[i],"-prewait")==0){
     tlock->prewait= 1;
   } else if(strcmp(argv[i],"-proc")==0 && i+1<argc){
     i++;
     strncpy(tlock->proc,argv[i],sizeof(tlock->proc)-1);
     tlock->proc[sizeof(tlock->proc)-1]= 0;
   } else if(strcmp(argv[i],"-lifetime")==0 && i+1<argc){
     i++;
     sscanf(argv[i],"%lf",&zahl);
     if(zahl!=0.0)
       tlock->expire_date= time(0)+zahl;
     else 
       tlock->expire_date= 1e40;
   } else if(strcmp(argv[i],"-exclusive")==0){
     tlock->exclusive= 1;
   } else if(strcmp(argv[i],"-non_exclusive")==0){
     tlock->exclusive= 0;
   } else if(strcmp(argv[i],"-action")==0 && i+1<argc){
     i++;
     if(strcmp(argv[i],"query")==0){
       tlock->action= 0;
     } else if(strcmp(argv[i],"lock")==0){
       tlock->action= 1;
     } else if(strcmp(argv[i],"release")==0){
       tlock->action= 2;
     } else if(strcmp(argv[i],"refresh")==0){
       tlock->action= 3;
     }else{
       fprintf(stderr,"%s : unknown option %s %s\n",argv[0],argv[i-1],argv[i]);
       return(1);
     }
   } else if(strcmp(argv[i],"-help")==0){
     Temp_lock_help(tlock,0);
     return(2);
   } else {
     fprintf(stderr,"%s : unknown option %s\n",argv[0],argv[i]);
     return(1);
   }
 }

 /* Schlussbearbeitung */
 if(tlock->address==0) {
   fprintf(stderr,"%s : no -name set\n",argv[0]);
   return(2);
 }

 return(0);
}


/* ----------------------------- main -------------------------- */


main(argc,argv)
int argc;
char **argv;
{
 struct Temp_locK tlk,*tlock;
 int ret;
 
 tlock= &tlk;

 Temp_lock_init(tlock,"",0,0,0);
 ret= Temp_lock_setup(tlock,argc,argv,0);
 if(ret!=0)
   exit(ret);
 ret= Temp_lock_perform(tlock,0);
 if(ret!=0 && ret!=1 && tlock->errmsg[0]!=0)
   fprintf(stderr,"%s\n",tlock->errmsg);
 exit(ret);
}
